package demo

import (
	"crypto/md5"
	"fmt"
	"io"
	"path/filepath"
	"strconv"
	"time"

	"../adapay/corpMember"
	"../adapay/utils"
)

/**
创建企业用户对象
文档说明：https://docs.adapay.tech/api/trade.html#id30
*/
func TestCorpMemberCreat() {
	createRefundParams := make(map[string]interface{})

	filePath, err := filepath.Abs("./ut/易付云.json")
	fmt.Println(filePath)
	// 填写请求参数
	// createRefundParams["env"] = "1"       // TODO
	// createRefundParams["prod_mode"] = "1" // TODO

	// 用当前的时间戳 作为 order_no 并且 md5之后 生成 member_id 这俩个参数只需要保证唯一性就可以
	crutime := time.Now().Unix()
	h := md5.New()
	io.WriteString(h, strconv.FormatInt(crutime, 15))
	member_id := fmt.Sprintf("%x", h.Sum(nil))

	createRefundParams["member_id"] = member_id
	createRefundParams["order_no"] = strconv.FormatInt(crutime, 10)
	createRefundParams["app_id"] = "app_7d87c043-aae3-4357-9b2c-269349a980d6"
	createRefundParams["prov_code"] = "上海市"
	createRefundParams["area_code"] = "3100"
	createRefundParams["social_credit_code"] = "123"
	createRefundParams["social_credit_code_expires"] = "20221231"
	createRefundParams["legal_person"] = "Kai"
	createRefundParams["legal_cert_id"] = "4330984882929094"
	createRefundParams["legal_mp"] = "18900000000"
	createRefundParams["attach_file"] = filePath
	createRefundParams["address"] = "企业地址测试"
	createRefundParams["name"] = "hahahh"

	data, apiError, err := corpMember.Create(createRefundParams, "merch_no_0000001")

	// 异常处理
	if err != nil { // 网络或本应用异常
		utils.Println("[DEMO] CorpMemberCreat Failed ---> " + err.Error())
		return
	}
	if apiError != nil { // adapay 服务返回异常
		utils.Println("[DEMO] CorpMemberCreat Failed ---> Response ---> ", apiError)
		return
	}

	/*
		TODO 成功处理
	*/

	utils.Println("[DEMO] CorpMemberCreat Success ---> ", data)
}

/**
查询企业用户对象
文档说明：https://docs.adapay.tech/api/trade.html#id31
*/
func TestCorpMemberQuery() {
	createRefundParams := make(map[string]interface{})

	createRefundParams["member_id"] = "83dc043f553c3737d421532dd6dc207b"
	createRefundParams["app_id"] = "app_7d87c043-aae3-4357-9b2c-269349a980d6"

	data, apiError, err := corpMember.Query(createRefundParams, "merch_no_0000001")

	// 异常处理
	if err != nil { // 网络或本应用异常
		utils.Println("[DEMO] CorpMemberCreat Failed ---> " + err.Error())
		return
	}
	if apiError != nil { // adapay 服务返回异常
		utils.Println("[DEMO] CorpMemberCreat Failed ---> Response ---> ", apiError)
		return
	}

	/*
		TODO 成功处理
	*/

	utils.Println("[DEMO] CorpMemberCreat Success ---> ", data)
}
