package refund

import (
	. "../gloable"
	. "../struts"
	"../utils"
	"errors"
	"fmt"
	"strings"
)

func Create(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	data := make(map[string]interface{})

	if reqParam["payment_id"] == nil {
		return data, nil, errors.New(fmt.Sprintf("请求参数错误 ==> %s", "payment_id"))
	}

	reqUrl := BASE_URL +
		strings.Replace(REFUND_CREATE, "{payment_id}", utils.ToString(reqParam["payment_id"]), -1)


	var msc MerchSysConfig
	if multiMerchConfigId == nil {
		msc = GDefaultMerchSysConfig
	} else {
		msc = utils.GetMerchSysConfig(multiMerchConfigId[0])
	}


	resp, err := utils.DoPostReq(reqUrl, reqParam, msc)
	if err != nil {
		return data, nil, errors.New(fmt.Sprintf("网络异常 ==> %s", err.Error()))
	}


	data, apiErr, err := utils.HandleResponse(resp, msc)
	if apiErr != nil || err != nil {
		return data, apiErr, err
	}


	if data["id"] == "" {
		return data, nil, errors.New(fmt.Sprintf("Refund 返回数据异常 ==> %s", data))
	}

	return data, nil, nil
}

func Query(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	data := make(map[string]interface{})

	reqUrl := BASE_URL + REFUND_QUERY


	var msc MerchSysConfig
	if multiMerchConfigId == nil {
		msc = GDefaultMerchSysConfig
	} else {
		msc = utils.GetMerchSysConfig(multiMerchConfigId[0])
	}


	resp, err := utils.DoGetReq(reqUrl, reqParam, msc)
	if err != nil {
		return data, nil, errors.New(fmt.Sprintf("网络异常 ==> %s", err.Error()))
	}


	data, apiErr, err := utils.HandleResponse(resp, msc)
	if apiErr != nil || err != nil {
		return data, apiErr, err
	}


	if data["id"] == "" {
		return data, nil, errors.New(fmt.Sprintf("Refund 返回数据异常 ==> %s", data))
	}

	return data, nil, nil
}
