package settleAccount

import (
	"errors"
	"fmt"
	"strings"

	. "../gloable"
	. "../struts"
	"../utils"
)

func Create(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	reqUrl := BASE_URL + SETTLE_ACCOUNT_CREATE
	return utils.RequestAdaPay(reqUrl, utils.POST, reqParam, multiMerchConfigId...)
}

func Query(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {

	if reqParam["settle_account_id"] == nil || reqParam["settle_account_id"] == "" {
		return make(map[string]interface{}), nil, errors.New(fmt.Sprintf("请求参数错误 ==> %s", "settle_account_id"))
	}
	reqUrl := BASE_URL + strings.Replace(SETTLE_ACCOUNT_QUERY, "{settle_account_id}", utils.ToString(reqParam["settle_account_id"]), -1)
	return utils.RequestAdaPay(reqUrl, utils.GET, reqParam, multiMerchConfigId...)
}

func Delete(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	reqUrl := BASE_URL + SETTLE_ACCOUNT_DELETE
	return utils.RequestAdaPay(reqUrl, utils.POST, reqParam, multiMerchConfigId...)
}

func QueryDetails(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	reqUrl := BASE_URL + SETTLE_ACCOUNT_DETAIL_QUERY
	return utils.RequestAdaPay(reqUrl, utils.GET, reqParam, multiMerchConfigId...)
}

func Modify(reqParam map[string]interface{}, multiMerchConfigId ...string) (map[string]interface{}, *ApiError, error) {
	reqUrl := BASE_URL + SETTLE_ACCOUNT_MODIFY
	return utils.RequestAdaPay(reqUrl, utils.POST, reqParam, multiMerchConfigId...)
}
