package utils

import (
	"encoding/json"
)

func ToString(v interface{}) string {
	switch v.(type) {
	case string:
		return v.(string)
	default:
		r, _ := json.Marshal(v)
		return string(r)
	}
}


func DeepCopy(value interface{}) interface{} {
	if valueMap, ok := value.(map[string]interface{}); ok {
		newMap := make(map[string]interface{})
		for k, v := range valueMap {
			newMap[k] = DeepCopy(v)
		}

		return newMap
	} else if valueSlice, ok := value.([]interface{}); ok {
		newSlice := make([]interface{}, len(valueSlice))
		for k, v := range valueSlice {
			newSlice[k] = DeepCopy(v)
		}

		return newSlice
	}

	return value
}
